Yandex Cloud
Search
Discuss with expertTry it for free
  • Customer Stories
  • Documentation
  • Blog
  • All Services
    • Cloud Interconnect
    • Cloud Backup
    • Cloud Registry
    • Yandex AI Studio
    • Compute Cloud
    • Object Storage
    • Managed Service for Kubernetes®
    • Yandex BareMetal
    • Smart Web Security
    • Security Deck
    • Managed Service for PostgreSQL
    • Managed Service for ClickHouse®
    • Monium
    • Cloud CDN
    • Network Load Balancer
    • Virtual Private Cloud
    • Cloud DNS
    • Application Load Balancer
    • Yandex Cloud Video
    • Stackland
    • Yandex Cloud Router
    • Yandex Managed Service for Trino
    • Managed Service for MySQL®
    • Managed Service for Valkey™
    • Managed Service for Apache Spark™
    • Yandex StoreDoc
    • Managed Service for OpenSearch
    • Managed Service for Apache Kafka®
    • Data Transfer
    • Yandex MPP Analytics Engine for PostgreSQL
    • Yandex Managed Service for Apache Airflow®
    • Data Processing
    • Yandex MetaData Hub
    • Managed Service for YDB
    • Managed Service for Sharded PostgreSQL
    • Managed Service for YTsaurus
    • Yandex WebSQL
    • DataLens
    • Yandex Search API
    • SpeechSense
    • SpeechKit
    • DataSphere
    • Vision OCR
    • Translate
    • Yandex Identity Hub
    • Key Management Service
    • Certificate Manager
    • Yandex Lockbox
    • Audit Trails
    • SmartCaptcha
    • Cloud Desktop
    • SourceCraft Code Assistant
    • Container Registry
    • Managed Service for GitLab
    • Managed Service for Prometheus®
    • Cloud Functions
    • API Gateway
    • Yandex Cloud Postbox
    • Message Queue
    • Serverless Integrations
    • IoT Core
    • Data Streams
    • Serverless Containers
    • Cloud Notification Service
    • Yandex Query
    • Identity and Access Management
    • Yandex Cloud Console
    • Resource Manager
    • Yandex Cloud Billing
    • Yandex Cloud Quota Manager
    • Cloud Apps
  • System Status
  • Marketplace
    • Featured
    • Infrastructure & Network
    • Data Platform
    • AI for business
    • Security
    • DevOps tools
    • Serverless
    • Monitoring & Resources
  • All Solutions
    • By industry
    • By use case
    • Economics and Pricing
    • Security
    • Technical Support
    • Start testing with double trial credits
    • Cloud credits to scale your IT product
    • Gateway to Russia
    • Cloud for Startups
    • Center for Technologies and Society
    • Yandex Cloud Partner program
    • Price calculator
    • Pricing plans
  • Customer Stories
  • Documentation
  • Blog
© 2026 Direct Cursus Technology L.L.C.
Yandex Object Storage
  • Pricing policy
  • Terraform reference
    • API authentication
      • How to use the API
      • Signing requests
      • Getting started with the S3 API
        • All services and methods
          • All methods
          • PutObject
          • GetObject
          • patch
          • CopyObject
          • HeadObject
          • DeleteObject
          • DeleteObjects
          • options
          • SelectObjectContent
          • PutObjectRetention
          • PutObjectLegalHold
          • GetObjectRetention
          • GetObjectLegalHold
          • PutObjectTagging
          • GetObjectTagging
          • DeleteObjectTagging
        • Common request headers
        • Common response headers
        • Responses
  • Monitoring metrics
  • Audit Trails events
  • Bucket logs
  • Release notes
  • FAQ

In this article:

  • Request
  • Path parameters
  • Headers
  • Response
  • Headers
  • Response codes
  • Data schema
  1. API reference
  2. AWS S3 REST
  3. REST
  4. Object
  5. patch

Object Storage API, Amazon S3-compatible REST: patch

Written by
Yandex Cloud
Updated at July 20, 2026
View in Markdown
  • Request
    • Path parameters
    • Headers
  • Response
    • Headers
    • Response codes
    • Data schema

Partially updates and appends object data in Yandex Object Storage.

Note

Basic S3 API operations do not include partial object update. This feature is supported for buckets with versioning disabled.

The request includes the updated object range and the new data.

Objects can be updated concurrently with multiple requests.

For more information on getting started with the API and the general request format, see How to use the S3 API.

RequestRequest

PATCH /{bucket}/{key} HTTP/2

Path parametersPath parameters

Parameter Description
bucket Bucket name.
key Object key, which is the ID the object is saved with in Object Storage.

HeadersHeaders

Use common headers in your request, as well as the headers below:

Header Description
Content-Range Required parameter.
Value: bytes {<start_byte>}-{<end_byte>}/*.
Range boundaries are included. The maximum range length is 5 GB.
The Content-Length header must be the same length as Content-Range.
To append data to an object, specify the end byte value larger than the object size.
The start byte value cannot exceed the object size.
The header format complies with RFC 9110 with the following exceptions:
  • The complete-length header parameter is ignored.
  • The last-pos header parameter is optional.
X-Yc-S3-Patch-Append-Part-Size Optional parameter.
Value: {size_of_the_new_part}.
The size of new parts of an object uploaded in parts, if appending to the end of the object. In bytes.
If the object's last part has reached the specified size, the next append will be saved as a new part.
The default value is 25 MB.
If-Match Optional parameter.
It defines the condition for partial object update.
If the ETag of an object matches the one specified in the header, the object is updated.
If the condition is not met, Object Storage returns the 412 Precondition Failed error.
You can use it with the If-Unmodified-Since header.
If-Unmodified-Since Optional parameter.
It defines the condition for partial object update.
The object is updated if it has not been modified since the specified time.
If the condition is not met, Object Storage returns the 412 Precondition Failed error.
You can use it with the If-Match header.

ResponseResponse

HeadersHeaders

Responses can only contain common headers.

Response codesResponse codes

For a list of possible responses, see Responses.

In addition, Object Storage can return other errors described in the table below.

Error Description
MissingContentRange The Content-Range header is missing from the request.
MalformedPatchAppendPartSize The X-Yc-S3-Patch-Append-Part-Size header in the request is invalid.
ObjectVersionPatchConflict During the partial update, the object was overwritten with a new version.
ConcurrentUpdatesPatchConflict The conflict could not be resolved due to a high number of concurrent requests.

Data schemaData schema

<?xml version="1.0" encoding="UTF-8"?>
<PatchObjectResult>
    <Object>
    	<LastModified>2023-07-21T11:46:16.357Z</LastModified>
        <ETag>&#34;daebcb5e72f14b690c18018c9f92af05-2&#34;</ETag>
    </Object>
</PatchObjectResult>
Tag Description
PatchObjectResult Root element.
Object Parent tag for update results.
LastModified Date and time when the object was last modified. In case of the partial object update, the tag does not change.
ETag ETag of the updated object. For more details, see common headers.

Related articlesRelated articles

  • Object

  • Partial object updates

Useful linksUseful links

  • Getting started with the AWS S3 API in Yandex Object Storage

  • Debugging requests using the AWS CLI

  • Example of sending a signed request using curl

  • Code example for generating a signature

Was the article helpful?

Previous
GetObject
Next
CopyObject
© 2026 Direct Cursus Technology L.L.C.